﻿using System;
using System.Collections.Generic;

namespace Astronomy
{
	/// <summary>
	/// Галактика - небесен обект (CelestialObject)
	/// </summary>
	public class Galaxy : CelestialObject
	{
		private readonly List<Asteroid> _asteroids;
		private readonly List<SolarSystem> _solarSystems;

		/// <summary>
		/// Астероиди в галактиката
		/// </summary>
		public List<Asteroid> Asteroids
		{
			get { return this._asteroids; }
		}

		/// <summary>
		/// Слънчеви системи в галактиката
		/// </summary>
		public List<SolarSystem> SolarSystems
		{
			get { return this._solarSystems; }
		}

		public Galaxy(string name)
			: base(name)
		{
			_solarSystems = new List<SolarSystem>();
			_asteroids = new List<Asteroid>();
		}

		#region IDumpable Members

		public override void Dump()
		{
			Console.WriteLine("Begin Galaxy '{0}'.", Name);

			Console.WriteLine("Solar Systems:");
			foreach (SolarSystem solarSystem in this._solarSystems)
			{
				solarSystem.Dump();
			}

			Console.WriteLine("Asteroids:");
			foreach (Asteroid asteroid in this._asteroids)
			{
				asteroid.Dump();
			}

			Console.WriteLine("End Galaxy '{0}'.", Name);
		}

		#endregion
	}
}
