﻿using System;

namespace Astronomy
{
	/// <summary>
	/// Изкуствен спътник - спътник (IMoon)
	/// </summary>
	public class Satellite : IMoon
	{
		private readonly string _name;
		private readonly IPrimary _primary;

		/// <summary>
		/// Наименование
		/// </summary>
		public string Name
		{
			get { return this._name; }
		}

		#region IDumpable Members

		public void Dump()
		{
			Console.WriteLine("Begin Satellite '{0}'.", this._name);

			Console.WriteLine("End Satellite '{0}'.", this._name);
		}

		#endregion

		#region IMoon Members

		public IPrimary Primary
		{
			get { return this._primary; }
		}

		public long DistanceToPrimary { get; set; }

		public TimeSpan RevolutionPeriod { get; set; }

		#endregion

		public Satellite(string name, IPrimary primary)
		{
			this._name = name;
			this._primary = primary;
		}
	}
}
