﻿using System;
using System.Collections.Generic;

namespace Astronomy
{
	/// <summary>
	/// Звезда - небесен обект (CelestialObject) със спътници (IPrimary)
	/// </summary>
	public class Star : CelestialObject, IPrimary
	{
		private readonly List<IMoon> _moons;

		#region IPrimary Members

		public List<IMoon> Moons
		{
			get { return _moons; }
		}

		#endregion

		/// <summary>
		/// Температура на повърхността
		/// </summary>
		public int SurfaceTemperature { get; set; }

		/// <summary>
		/// Кара звездата да свети.
		/// </summary>
		public void Shine()
		{
			throw new NotImplementedException();
		}

		/// <summary>
		/// Завърта звездата около оста и.
		/// </summary>
		public void Spin()
		{
			throw new NotImplementedException();
		}

		public Star(string name)
			: base(name)
		{
			this._moons = new List<IMoon>();
		}

		public override void Dump()
		{
			Console.WriteLine("Begin Star '{0}'.", Name);

			Console.WriteLine("Moons:");
			foreach (IMoon moon in this._moons)
			{
				moon.Dump();
			}

			Console.WriteLine("End Star '{0}'.", Name);
		}
	}
}
