﻿using System;

namespace Astronomy
{
	/// <summary>
	/// Вселена. Една единствена (Singleton).
	/// </summary>
	public class Universe
	{
		private readonly Guid _guid;

		public Guid Guid
		{
			get { return _guid; }
		}

		private Universe()
		{
			this._guid = Guid.NewGuid();
		}

		#region Alternative 1. Статична променлива инициализирана при нужда

		//private static Universe _singleton;

		//public static Universe Create()
		//{
		//    if (_singleton == null)
		//        _singleton = new Universe();

		//    return _singleton;
		//}

		#endregion

		#region Alternative 2. Статична променлива инициализирана при зареждане на класа

		//private readonly static Universe _singleton = new Universe();

		//public static Universe Create()
		//{
		//    return _singleton;
		//}

		#endregion

		#region Alternative 3. Статична променлива инициализирана в статичен конструктор

		private readonly static Universe _singleton;

		static Universe()
		{
			_singleton = new Universe();
		}

		public static Universe Create()
		{
			return _singleton;
		}

		#endregion
	}
}
