﻿using System;
using System.IO;

namespace Exceptions
{
	internal class Program
	{
		private static void Main(string[] args)
		{
			var processor = new Processor();
			processor.Process();

			string fileName = Path.GetTempFileName();

			#region Баламският начин

			//FileStream stream = new FileStream(fileName, FileMode.Truncate);
			//try
			//{
			//    byte[] bytes = new byte[1024];
			//    new Random().NextBytes(bytes);
			//    stream.Write(bytes, 0, bytes.Length);
			//}
			//finally
			//{
			//    stream.Close();
			//}

			#endregion

			#region Тарикатският начин ("using" и IDisposable)

			using (FileStream fs = new FileStream(fileName, FileMode.Truncate))
			{
				byte[] bytes = new byte[1024];
				new Random().NextBytes(bytes);
				fs.Write(bytes, 0, bytes.Length);
			}

			#endregion

			Console.ReadLine();
		}
	}
}
