﻿using System.Collections;

namespace Generics
{
	/// <summary>
	/// Списък от елементи
	/// </summary>
	/// <typeparam name="TItem">Тип на елемента MyItem или негов наследник с подразбиращ се конструктор</typeparam>
	public class MyItemList<TItem>
		where TItem : MyItem, new()
	{
		private readonly ArrayList _items;

		public MyItemList()
		{
			this._items = new ArrayList();
		}

		public void Add(TItem item)
		{
			this._items.Add(item);
		}

		public void Remove(TItem item)
		{
			this._items.Remove(item);
		}

		public void Clear()
		{
			this._items.Clear();
		}

		public TItem Get(int index)
		{
			object element = this._items[index];

			return (TItem)element;
		}

		public int Count
		{
			get { return this._items.Count; }
		}

		public TItem Create()
		{
			TItem item = new TItem();

			Add(item);

			return item;
		}
	}
}
