﻿using System;

namespace Generics
{
	internal class Program
	{
		private static void ShowType<T>(T obj)
		{
			Console.WriteLine("Type is {0}.", typeof(T));
		}

		private static void ShowTypes<T1, T2>(T1 obj1, T2 obj2)
			where T1 : MyItem
			where T2 : T1
		{
			Console.WriteLine("Type 1 is {0}.", typeof(T1));
			Console.WriteLine("Type 2 is {0}.", typeof(T2));
		}

		private static void Main(string[] args)
		{
			#region MyItemList of MyItem

			var itemList = new MyItemList<MyItem>();

			MyItem item1 = itemList.Create();
			item1.Name = "Alabalanica!";

			MyItem item2 = itemList.Create();
			item2.Name = "Abracaddabra!";

			Console.WriteLine(itemList.Get(0).Name);

			itemList.Remove(item1);

			Console.WriteLine(itemList.Get(0).Name);

			Console.WriteLine("Item list size is {0}.", itemList.Count);

			#endregion

			#region Template methods

			ShowType<int>(5);
			ShowType<string>("Alabalanica!");
			ShowType<double>(5.3);

			ShowTypes<MyItem, MyItem>(item1, item2);

			#endregion
		}
	}
}
