﻿using System;

namespace Geometry
{
	/// <summary>
	/// Точка в двумерното пространство
	/// </summary>
	public class Point
	{
		/// <summary>
		/// Координата X на точката
		/// </summary>
		public double X;

		/// <summary>
		/// Координата Y на точката
		/// </summary>
		public double Y;

		/// <summary>
		/// Цвят на точката
		/// </summary>
		public Color Color;

		/// <summary>
		/// Премества точката.
		/// </summary>
		/// <param name="vector">Вектор на преместването</param>
		public void Move(Vector vector)
		{
			this.X += vector.X;
			this.Y += vector.Y;
		}

		/// <summary>
		/// Взима разстоянието до друга точка.
		/// </summary>
		/// <param name="point">Точка, до която да се измери разстоянието</param>
		/// <returns>Разстояние до другата точка</returns>
		public double DistanceTo(Point point)
		{
			return Math.Sqrt(Math.Pow(point.X - this.X, 2) + Math.Pow(point.Y - this.Y, 2));
		}
	}
}
