﻿namespace Geometry
{
	/// <summary>
	/// Абстрактен клас за фигура
	/// </summary>
	public abstract class Shape
	{
		/// <summary>
		/// Цвят на пълнежа
		/// </summary>
		public Color Color;

		/// <summary>
		/// Цвят на рамката
		/// </summary>
		public Color BorderColor;

		/// <summary>
		/// Премества фигурата в двумерното простанство.
		/// </summary>
		/// <param name="vector">Вектор на преместването</param>
		public abstract void Move(Vector vector);

		/// <summary>
		/// Запълва фигурата с определен цвят.
		/// </summary>
		/// <param name="color">Цвят, с който да бъде запълнена фигурата</param>
		public void Fill(Color color)
		{
			this.Color = color;
		}

		/// <summary>
		/// Взима лицето на фигурата.
		/// </summary>
		/// <returns>Лице на фигурата</returns>
		public abstract double GetSurface();
	}
}
