﻿using System;

namespace Geometry
{
	/// <summary>
	/// Триъгълник в двумерното пространство
	/// </summary>
	public class Triangle : Shape
	{
		/// <summary>
		/// Връх на триъгълника
		/// </summary>
		public Point A, B, C;

		public override void Move(Vector vector)
		{
			this.A.Move(vector);
			this.B.Move(vector);
			this.C.Move(vector);
		}

		public override double GetSurface()
		{
			double a = this.B.DistanceTo(this.C);
			double b = this.C.DistanceTo(this.A);
			double c = this.A.DistanceTo(this.B);
			double p = (a + b + c) / 2;

			return Math.Sqrt(p * (p - a) * (p - b) * (p - c));
		}
	}
}
