﻿
namespace Lights
{
	public class Light
	{
		#region Частни полета (отразяват състоянието)

		private bool _isOn;

		private double _intensity;

		#endregion

		#region Свойства и методи (отразяват поведението)

		/// <summary>
		/// Включено/изключено
		/// </summary>
		public bool IsOn
		{
			get { return this._isOn; }
		}

		/// <summary>
		/// Интензитет на светлината
		/// </summary>
		public double Intensity
		{
			get { return this._intensity; }
		}

		/// <summary>
		/// Включва светлината.
		/// </summary>
		public void TurnOn()
		{
			this._isOn = true;
		}

		/// <summary>
		/// Изключва светлината.
		/// </summary>
		public void TurnOff()
		{
			this._isOn = false;
		}

		/// <summary>
		/// Притъмнява с определена стъпка.
		/// </summary>
		/// <param name="step">Стъпка, с която се притъмнява</param>
		public void Dim(double step)
		{
			if (this._intensity - step <= 0)
				this._intensity = 0;
			else
				this._intensity -= step;
		}

		/// <summary>
		/// Осветява с определена стъпка.
		/// </summary>
		/// <param name="step">Стъпка, с която се осветява</param>
		public void Brighten(double step)
		{
			if (this._intensity + step >= 100)
				this._intensity = 100;
			else
				this._intensity += step;
		}

		#endregion
	}
}
